<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfKategoriDil ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfKategoriDil
 * @subpackage Arrays
 */
class ArrayOfKategoriDil extends AbstractStructArrayBase
{
    /**
     * The KategoriDil
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\KategoriDil[]
     */
    public $KategoriDil;
    /**
     * Constructor method for ArrayOfKategoriDil
     * @uses ArrayOfKategoriDil::setKategoriDil()
     * @param \StructType\KategoriDil[] $kategoriDil
     */
    public function __construct(array $kategoriDil = array())
    {
        $this
            ->setKategoriDil($kategoriDil);
    }
    /**
     * Get KategoriDil value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\KategoriDil[]|null
     */
    public function getKategoriDil()
    {
        return isset($this->KategoriDil) ? $this->KategoriDil : null;
    }
    /**
     * This method is responsible for validating the values passed to the setKategoriDil method
     * This method is willingly generated in order to preserve the one-line inline validation within the setKategoriDil method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateKategoriDilForArrayConstraintsFromSetKategoriDil(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfKategoriDilKategoriDilItem) {
            // validation for constraint: itemType
            if (!$arrayOfKategoriDilKategoriDilItem instanceof \StructType\KategoriDil) {
                $invalidValues[] = is_object($arrayOfKategoriDilKategoriDilItem) ? get_class($arrayOfKategoriDilKategoriDilItem) : sprintf('%s(%s)', gettype($arrayOfKategoriDilKategoriDilItem), var_export($arrayOfKategoriDilKategoriDilItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The KategoriDil property can only contain items of type \StructType\KategoriDil, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set KategoriDil value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\KategoriDil[] $kategoriDil
     * @return \ArrayType\ArrayOfKategoriDil
     */
    public function setKategoriDil(array $kategoriDil = array())
    {
        // validation for constraint: array
        if ('' !== ($kategoriDilArrayErrorMessage = self::validateKategoriDilForArrayConstraintsFromSetKategoriDil($kategoriDil))) {
            throw new \InvalidArgumentException($kategoriDilArrayErrorMessage, __LINE__);
        }
        if (is_null($kategoriDil) || (is_array($kategoriDil) && empty($kategoriDil))) {
            unset($this->KategoriDil);
        } else {
            $this->KategoriDil = $kategoriDil;
        }
        return $this;
    }
    /**
     * Add item to KategoriDil value
     * @throws \InvalidArgumentException
     * @param \StructType\KategoriDil $item
     * @return \ArrayType\ArrayOfKategoriDil
     */
    public function addToKategoriDil(\StructType\KategoriDil $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\KategoriDil) {
            throw new \InvalidArgumentException(sprintf('The KategoriDil property can only contain items of type \StructType\KategoriDil, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->KategoriDil[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\KategoriDil|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\KategoriDil|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\KategoriDil|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\KategoriDil|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\KategoriDil|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string KategoriDil
     */
    public function getAttributeName()
    {
        return 'KategoriDil';
    }
}
